package korobkin.example.app;

import androidx.appcompat.app.AppCompatActivity;

import android.content.ContentValues;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ListView;
import android.widget.SimpleCursorAdapter;
import android.widget.TextView;


public class MainActivity extends AppCompatActivity implements View.OnClickListener {

    ListView userList;
    Cursor userCursor;
    SimpleCursorAdapter userAdapter;
    SQLiteDatabase db;
    TextView header;

    Button btnAdd, btnDelete, btnRead, btnUpdate;
    EditText etName, etDescription, etId;

    Database dbHelper;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);

        btnAdd = (Button) findViewById(R.id.btnAdd);
        btnAdd.setOnClickListener(this);

        btnDelete = (Button) findViewById(R.id.btnDelete);
        btnDelete.setOnClickListener(this);

        btnUpdate = (Button) findViewById(R.id.btnUpdate);
        btnUpdate.setOnClickListener(this);

        btnRead = (Button) findViewById(R.id.btnRead);
        btnRead.setOnClickListener(this);

        etName = (EditText) findViewById(R.id.u_name);
        etDescription = (EditText) findViewById(R.id.u_description);
        etId = (EditText) findViewById(R.id.u_id);

                userList = (ListView)findViewById(R.id.listView);

        dbHelper = new Database(this);
    }

    @Override
    public void onResume() {
        super.onResume();
        // открываем подключение
        db = dbHelper.getReadableDatabase();
        //получаем данные из бд в виде курсора
        userCursor =  db.rawQuery("select * from "+ dbHelper.TABLE_CONTACTS, null);
        // определяем, какие столбцы из курсора будут выводиться в ListView
        String[] headers = new String[] {Database.KEY_NAME, Database.KEY_DESCRIPTION};
        // создаем адаптер, передаем в него курсор
        userAdapter = new SimpleCursorAdapter(this, android.R.layout.two_line_list_item,
                userCursor, headers, new int[]{android.R.id.text1, android.R.id.text2}, 0);

        userList.setAdapter(userAdapter);
    }

    @Override
    public void onDestroy(){
        super.onDestroy();
        // Закрываем подключение и курсор
        db.close();
        userCursor.close();
    }

    @Override
    public void onClick(View v) {

        String Name = etName.getText().toString();
        String Description = etDescription.getText().toString();
        String Id = etId.getText().toString();

        SQLiteDatabase database = dbHelper.getWritableDatabase();

        ContentValues contentValues = new ContentValues();

        switch (v.getId()) {
            case R.id.btnAdd:
                contentValues.put(Database.KEY_NAME, Name);
                contentValues.put(Database.KEY_DESCRIPTION, Description);

                database.insert(Database.TABLE_CONTACTS, null, contentValues);
                break;

            case R.id.btnRead:
                Cursor cursor = database.query(Database.TABLE_CONTACTS,null,null,null,null,null,null);

                if(cursor.moveToFirst()) {
                    int idIndex = cursor.getColumnIndex(Database.KEY_ID);
                    int nameIndex = cursor.getColumnIndex(Database.KEY_NAME);
                    int descriptionIndex = cursor.getColumnIndex(Database.KEY_DESCRIPTION);
                        do {
                            Log.d("mLog", "ID = " + cursor.getInt(idIndex) +
                                    ", name = " + cursor.getInt(nameIndex) +
                                    ", description = " + cursor.getInt(descriptionIndex));
                        } while (cursor.moveToNext());
                } else
                    Log.d("mLog","0 rows");
                cursor.close();
                break;

            case R.id.btnDelete:
                if (Id.equalsIgnoreCase("")) {
                    break;
                }
                int deleteCount = database.delete(Database.TABLE_CONTACTS, Database.KEY_ID + "=" +Id, null);

                Log.d("mLog", "deleted rows count = " + deleteCount);

            case R.id.btnUpdate:
                if(Id.equalsIgnoreCase("")) {
                    break;
                }
                contentValues.put(Database.KEY_NAME, Name);
                contentValues.put(Database.KEY_DESCRIPTION, Description);
                int updateCount = database.update(Database.TABLE_CONTACTS, contentValues, Database.KEY_ID + "= ? ", new String[] {Id});

                Log.d("mLog", "updates_rows count = " + updateCount);


        }

        dbHelper.close();
    }
}